VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   4905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6510
   LinkTopic       =   "Form1"
   ScaleHeight     =   327
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   434
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar HScroll1 
      Height          =   135
      Index           =   2
      Left            =   120
      Max             =   512
      TabIndex        =   3
      Top             =   4680
      Value           =   256
      Width           =   6255
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   135
      Index           =   1
      Left            =   120
      Max             =   512
      TabIndex        =   2
      Top             =   4440
      Value           =   256
      Width           =   6255
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   135
      Index           =   0
      Left            =   120
      Max             =   512
      TabIndex        =   1
      Top             =   4200
      Value           =   256
      Width           =   6255
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   4005
      Left            =   120
      ScaleHeight     =   263
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   414
      TabIndex        =   0
      Top             =   120
      Width           =   6270
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Anmerkung: Wie immer bei grafischen Manipulationen sollte der
'           Source zum besseren Genu erst als Exe kompiliert
'           werden!

Option Explicit

Private Declare Function GetBitmapBits Lib "gdi32" (ByVal _
        hBitmap As Long, ByVal dwCount As Long, lpBits As Any) _
        As Long
        
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal _
        hBitmap As Long, ByVal dwCount As Long, lpBits As Any) _
        As Long

Private Declare Function GetObject Lib "gdi32" Alias _
        "GetObjectA" (ByVal hObject As Long, ByVal nCount As _
        Long, lpObject As Any) As Long
        
Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

'Byte Arrays fr die Bitmap
Dim PicO() As Byte
Dim PicW() As Byte
Private Blend(0 To 255, 0 To 2) As Byte

Dim ColRes As Long
Dim Init As Boolean

Private Sub Form_Load()
  Dim x As Integer
  
    Picture1.Picture = LoadPicture(App.Path & "\vbufo.jpg")
    For x = 0 To 255
      Blend(x, 0) = x
      Blend(x, 1) = x
      Blend(x, 2) = x
    Next x
End Sub

Private Sub HScroll1_Change(Index As Integer)
  Call MakeBlend(Index)
End Sub

Private Sub HScroll1_Scroll(Index As Integer)
  Call MakeBlend(Index)
End Sub

Private Sub MakeBlend(Index As Integer)
  Dim x As Long, x1 As Integer
    
    If Not Init Then
      Call InitArray(PicO, PicW)
      Init = True
    End If
    
    For x = 0 To 255
      x1 = x + HScroll1(Index).Value - 256
      
      If x1 > 255 Then
        x1 = 255
      ElseIf x1 < 0 Then
        x1 = 0
      End If
      
      Blend(x, Index) = x1
    Next x
    
    Call FilterArray(PicO, PicW)
End Sub

Private Sub FilterArray(F1() As Byte, F2() As Byte)
  Dim x As Long
  
    'Filter berrechnen
    For x = 0 To UBound(F1) - 2 Step ColRes
      F2(x) = Blend(F1(x), 2)
      F2(x + 1) = Blend(F1(x + 1), 1)
      F2(x + 2) = Blend(F1(x + 2), 0)
    Next x

    'Bild zurckschreiben
    Call SetBitmapBits(Picture1.Image, UBound(F2), F2(0))
                       
    'Image bernehmen
    Picture1.Refresh
End Sub

Private Sub InitArray(F1() As Byte, F2() As Byte)
  Dim PInf As BITMAP
 
    'Abmae ermitteln
    Call GetObject(Picture1.Image, Len(PInf), PInf)
    
    With PInf
      'Eingestellte Farbtiefe ermitteln
      ColRes = .bmBitsPixel / 8

      If ColRes <> 3 And ColRes <> 4 Then
         MsgBox ("Stellen Sie Ihre Bildschirmauflsung bitte" & _
                 " vorab auf 24 oder 32 Bit Farbtiefe um!")
         End
      End If
      
      'Arrays dimensionieren
      ReDim F1(0 To .bmWidth * .bmHeight * ColRes - 1) As Byte
      ReDim F2(0 To .bmWidth * .bmHeight * ColRes - 1) As Byte
      
    End With
    
    'Bitmap in das Array kopieren
    Call GetBitmapBits(Picture1.Image, UBound(F1), F1(0))
    Call GetBitmapBits(Picture1.Image, UBound(F2), F2(0))
End Sub
